/*
 * Copyright (C) 2023 Open Source Robotics Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
*/

/* This file was automatically generated.
 * Do not edit this directly
 */

#include "gz/msgs/Factory.hh"
#include "gz/msgs/MessageFactory.hh"
#include "gz/msgs/MessageTypes.hh"

#include <array>

namespace {
    using NamedFactoryFn = std::pair<std::string, gz::msgs::MessageFactory::FactoryFn>;

    std::array<NamedFactoryFn, 217> kFactoryFunctions = {{
  {"gz.msgs.Actor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Actor>();}},
  {"gz.msgs.Actuators",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Actuators>();}},
  {"gz.msgs.AirPressureSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AirPressureSensor>();}},
  {"gz.msgs.AirSpeed",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AirSpeed>();}},
  {"gz.msgs.AirSpeedSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AirSpeedSensor>();}},
  {"gz.msgs.Altimeter",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Altimeter>();}},
  {"gz.msgs.AltimeterSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AltimeterSensor>();}},
  {"gz.msgs.AnnotatedAxisAligned2DBox",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AnnotatedAxisAligned2DBox>();}},
  {"gz.msgs.AnnotatedAxisAligned2DBox_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AnnotatedAxisAligned2DBox_V>();}},
  {"gz.msgs.AnnotatedOriented3DBox",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AnnotatedOriented3DBox>();}},
  {"gz.msgs.AnnotatedOriented3DBox_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AnnotatedOriented3DBox_V>();}},
  {"gz.msgs.Any",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Any>();}},
  {"gz.msgs.Atmosphere",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Atmosphere>();}},
  {"gz.msgs.Axis",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Axis>();}},
  {"gz.msgs.AxisAligned2DBox",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AxisAligned2DBox>();}},
  {"gz.msgs.AxisAlignedBox",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::AxisAlignedBox>();}},
  {"gz.msgs.Battery",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Battery>();}},
  {"gz.msgs.BatteryState",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::BatteryState>();}},
  {"gz.msgs.Boolean",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Boolean>();}},
  {"gz.msgs.BoxGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::BoxGeom>();}},
  {"gz.msgs.Bytes",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Bytes>();}},
  {"gz.msgs.CameraCmd",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::CameraCmd>();}},
  {"gz.msgs.CameraInfo",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::CameraInfo>();}},
  {"gz.msgs.CameraLens",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::CameraLens>();}},
  {"gz.msgs.CameraSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::CameraSensor>();}},
  {"gz.msgs.CapsuleGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::CapsuleGeom>();}},
  {"gz.msgs.Cessna",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Cessna>();}},
  {"gz.msgs.Clock",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Clock>();}},
  {"gz.msgs.CmdVel2D",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::CmdVel2D>();}},
  {"gz.msgs.Collision",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Collision>();}},
  {"gz.msgs.Color",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Color>();}},
  {"gz.msgs.ConeGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ConeGeom>();}},
  {"gz.msgs.Contact",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Contact>();}},
  {"gz.msgs.Contacts",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Contacts>();}},
  {"gz.msgs.ContactSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ContactSensor>();}},
  {"gz.msgs.CylinderGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::CylinderGeom>();}},
  {"gz.msgs.DataLoadPathOptions",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::DataLoadPathOptions>();}},
  {"gz.msgs.Dataframe",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Dataframe>();}},
  {"gz.msgs.Density",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Density>();}},
  {"gz.msgs.Diagnostics",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Diagnostics>();}},
  {"gz.msgs.Discovery",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Discovery>();}},
  {"gz.msgs.Distortion",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Distortion>();}},
  {"gz.msgs.Double",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Double>();}},
  {"gz.msgs.Double_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Double_V>();}},
  {"gz.msgs.Duration",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Duration>();}},
  {"gz.msgs.DVLBeamState",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::DVLBeamState>();}},
  {"gz.msgs.DVLKinematicEstimate",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::DVLKinematicEstimate>();}},
  {"gz.msgs.DVLRangeEstimate",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::DVLRangeEstimate>();}},
  {"gz.msgs.DVLTrackingTarget",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::DVLTrackingTarget>();}},
  {"gz.msgs.DVLVelocityTracking",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::DVLVelocityTracking>();}},
  {"gz.msgs.EllipsoidGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::EllipsoidGeom>();}},
  {"gz.msgs.Empty",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Empty>();}},
  {"gz.msgs.Entity",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Entity>();}},
  {"gz.msgs.EntityFactory",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::EntityFactory>();}},
  {"gz.msgs.EntityFactory_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::EntityFactory_V>();}},
  {"gz.msgs.EntityPlugin_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::EntityPlugin_V>();}},
  {"gz.msgs.EntityWrench",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::EntityWrench>();}},
  {"gz.msgs.EntityWrenchMap",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::EntityWrenchMap>();}},
  {"gz.msgs.Float",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Float>();}},
  {"gz.msgs.Float_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Float_V>();}},
  {"gz.msgs.Fluid",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Fluid>();}},
  {"gz.msgs.FluidPressure",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::FluidPressure>();}},
  {"gz.msgs.Fog",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Fog>();}},
  {"gz.msgs.Friction",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Friction>();}},
  {"gz.msgs.FuelMetadata",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::FuelMetadata>();}},
  {"gz.msgs.Geometry",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Geometry>();}},
  {"gz.msgs.GPS",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::GPS>();}},
  {"gz.msgs.GPSSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::GPSSensor>();}},
  {"gz.msgs.GUI",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::GUI>();}},
  {"gz.msgs.GUICamera",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::GUICamera>();}},
  {"gz.msgs.Header",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Header>();}},
  {"gz.msgs.HeightmapGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::HeightmapGeom>();}},
  {"gz.msgs.Hydra",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Hydra>();}},
  {"gz.msgs.Image",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Image>();}},
  {"gz.msgs.ImageGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ImageGeom>();}},
  {"gz.msgs.IMU",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::IMU>();}},
  {"gz.msgs.IMUSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::IMUSensor>();}},
  {"gz.msgs.Inertial",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Inertial>();}},
  {"gz.msgs.Int32",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Int32>();}},
  {"gz.msgs.Int32_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Int32_V>();}},
  {"gz.msgs.Int64",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Int64>();}},
  {"gz.msgs.Int64_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Int64_V>();}},
  {"gz.msgs.Joint",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Joint>();}},
  {"gz.msgs.JointAnimation",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::JointAnimation>();}},
  {"gz.msgs.JointCmd",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::JointCmd>();}},
  {"gz.msgs.JointTrajectory",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::JointTrajectory>();}},
  {"gz.msgs.JointTrajectoryPoint",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::JointTrajectoryPoint>();}},
  {"gz.msgs.JointWrench",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::JointWrench>();}},
  {"gz.msgs.Joy",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Joy>();}},
  {"gz.msgs.Joystick",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Joystick>();}},
  {"gz.msgs.LaserScan",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::LaserScan>();}},
  {"gz.msgs.Lens",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Lens>();}},
  {"gz.msgs.LidarSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::LidarSensor>();}},
  {"gz.msgs.Light",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Light>();}},
  {"gz.msgs.Link",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Link>();}},
  {"gz.msgs.LinkData",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::LinkData>();}},
  {"gz.msgs.LogControl",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::LogControl>();}},
  {"gz.msgs.LogPlaybackControl",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::LogPlaybackControl>();}},
  {"gz.msgs.LogPlaybackStatistics",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::LogPlaybackStatistics>();}},
  {"gz.msgs.LogStatus",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::LogStatus>();}},
  {"gz.msgs.LogicalCameraImage",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::LogicalCameraImage>();}},
  {"gz.msgs.LogicalCameraSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::LogicalCameraSensor>();}},
  {"gz.msgs.Magnetometer",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Magnetometer>();}},
  {"gz.msgs.MagnetometerSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::MagnetometerSensor>();}},
  {"gz.msgs.Marker",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Marker>();}},
  {"gz.msgs.Marker_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Marker_V>();}},
  {"gz.msgs.Material",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Material>();}},
  {"gz.msgs.MaterialColor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::MaterialColor>();}},
  {"gz.msgs.MeshGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::MeshGeom>();}},
  {"gz.msgs.Model",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Model>();}},
  {"gz.msgs.ModelConfiguration",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ModelConfiguration>();}},
  {"gz.msgs.Model_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Model_V>();}},
  {"gz.msgs.NavSat",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::NavSat>();}},
  {"gz.msgs.NavSatSensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::NavSatSensor>();}},
  {"gz.msgs.OccupancyGrid",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::OccupancyGrid>();}},
  {"gz.msgs.Odometry",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Odometry>();}},
  {"gz.msgs.OdometryWithCovariance",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::OdometryWithCovariance>();}},
  {"gz.msgs.Oriented3DBox",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Oriented3DBox>();}},
  {"gz.msgs.Packet",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Packet>();}},
  {"gz.msgs.Param",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Param>();}},
  {"gz.msgs.Param_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Param_V>();}},
  {"gz.msgs.Parameter",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Parameter>();}},
  {"gz.msgs.ParameterDeclaration",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ParameterDeclaration>();}},
  {"gz.msgs.ParameterDeclarations",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ParameterDeclarations>();}},
  {"gz.msgs.ParameterError",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ParameterError>();}},
  {"gz.msgs.ParameterName",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ParameterName>();}},
  {"gz.msgs.ParameterValue",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ParameterValue>();}},
  {"gz.msgs.ParticleEmitter",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ParticleEmitter>();}},
  {"gz.msgs.ParticleEmitter_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ParticleEmitter_V>();}},
  {"gz.msgs.PerformanceSensorMetrics",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PerformanceSensorMetrics>();}},
  {"gz.msgs.Physics",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Physics>();}},
  {"gz.msgs.PID",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PID>();}},
  {"gz.msgs.PlaneGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PlaneGeom>();}},
  {"gz.msgs.Plugin",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Plugin>();}},
  {"gz.msgs.Plugin_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Plugin_V>();}},
  {"gz.msgs.PointCloud",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PointCloud>();}},
  {"gz.msgs.PointCloudPacked",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PointCloudPacked>();}},
  {"gz.msgs.Polyline",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Polyline>();}},
  {"gz.msgs.Pose",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Pose>();}},
  {"gz.msgs.PoseAnimation",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PoseAnimation>();}},
  {"gz.msgs.PoseTrajectory",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PoseTrajectory>();}},
  {"gz.msgs.Pose_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Pose_V>();}},
  {"gz.msgs.PoseWithCovariance",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PoseWithCovariance>();}},
  {"gz.msgs.Projector",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Projector>();}},
  {"gz.msgs.PropagationGrid",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PropagationGrid>();}},
  {"gz.msgs.PropagationParticle",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::PropagationParticle>();}},
  {"gz.msgs.Publish",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Publish>();}},
  {"gz.msgs.Publishers",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Publishers>();}},
  {"gz.msgs.Quaternion",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Quaternion>();}},
  {"gz.msgs.RaySensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::RaySensor>();}},
  {"gz.msgs.Request",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Request>();}},
  {"gz.msgs.Response",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Response>();}},
  {"gz.msgs.RestLogin",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::RestLogin>();}},
  {"gz.msgs.RestLogout",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::RestLogout>();}},
  {"gz.msgs.RestPost",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::RestPost>();}},
  {"gz.msgs.RestResponse",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::RestResponse>();}},
  {"gz.msgs.Road",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Road>();}},
  {"gz.msgs.Scene",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Scene>();}},
  {"gz.msgs.SdfGeneratorConfig",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SdfGeneratorConfig>();}},
  {"gz.msgs.Selection",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Selection>();}},
  {"gz.msgs.Sensor",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Sensor>();}},
  {"gz.msgs.SensorNoise",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SensorNoise>();}},
  {"gz.msgs.Sensor_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Sensor_V>();}},
  {"gz.msgs.SerializedComponent",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SerializedComponent>();}},
  {"gz.msgs.SerializedEntity",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SerializedEntity>();}},
  {"gz.msgs.SerializedState",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SerializedState>();}},
  {"gz.msgs.SerializedStep",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SerializedStep>();}},
  {"gz.msgs.SerializedEntityMap",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SerializedEntityMap>();}},
  {"gz.msgs.SerializedStateMap",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SerializedStateMap>();}},
  {"gz.msgs.SerializedStepMap",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SerializedStepMap>();}},
  {"gz.msgs.ServerControl",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::ServerControl>();}},
  {"gz.msgs.Shadows",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Shadows>();}},
  {"gz.msgs.SimEvent",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SimEvent>();}},
  {"gz.msgs.Sky",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Sky>();}},
  {"gz.msgs.Sonar",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Sonar>();}},
  {"gz.msgs.SphereGeom",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SphereGeom>();}},
  {"gz.msgs.SphericalCoordinates",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::SphericalCoordinates>();}},
  {"gz.msgs.Statistic",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Statistic>();}},
  {"gz.msgs.StatisticsGroup",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::StatisticsGroup>();}},
  {"gz.msgs.Metric",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Metric>();}},
  {"gz.msgs.StringMsg",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::StringMsg>();}},
  {"gz.msgs.StringMsg_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::StringMsg_V>();}},
  {"gz.msgs.Subscribe",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Subscribe>();}},
  {"gz.msgs.Surface",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Surface>();}},
  {"gz.msgs.Tactile",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Tactile>();}},
  {"gz.msgs.Test",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Test>();}},
  {"gz.msgs.Time",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Time>();}},
  {"gz.msgs.TopicInfo",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::TopicInfo>();}},
  {"gz.msgs.TrackVisual",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::TrackVisual>();}},
  {"gz.msgs.Twist",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Twist>();}},
  {"gz.msgs.TwistWithCovariance",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::TwistWithCovariance>();}},
  {"gz.msgs.UInt32",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::UInt32>();}},
  {"gz.msgs.UInt32_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::UInt32_V>();}},
  {"gz.msgs.UInt64",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::UInt64>();}},
  {"gz.msgs.UInt64_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::UInt64_V>();}},
  {"gz.msgs.UndoRedo",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::UndoRedo>();}},
  {"gz.msgs.UserCmd",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::UserCmd>();}},
  {"gz.msgs.UserCmdStats",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::UserCmdStats>();}},
  {"gz.msgs.Vector2d",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Vector2d>();}},
  {"gz.msgs.Vector3d",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Vector3d>();}},
  {"gz.msgs.Version",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Version>();}},
  {"gz.msgs.VersionRange",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::VersionRange>();}},
  {"gz.msgs.VersionedName",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::VersionedName>();}},
  {"gz.msgs.VideoRecord",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::VideoRecord>();}},
  {"gz.msgs.Visual",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Visual>();}},
  {"gz.msgs.Visual_V",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Visual_V>();}},
  {"gz.msgs.WebRequest",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::WebRequest>();}},
  {"gz.msgs.WheelSlipParametersCmd",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::WheelSlipParametersCmd>();}},
  {"gz.msgs.Wind",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Wind>();}},
  {"gz.msgs.WirelessNode",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::WirelessNode>();}},
  {"gz.msgs.WirelessNodes",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::WirelessNodes>();}},
  {"gz.msgs.WorldControl",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::WorldControl>();}},
  {"gz.msgs.WorldControlState",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::WorldControlState>();}},
  {"gz.msgs.WorldModify",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::WorldModify>();}},
  {"gz.msgs.WorldReset",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::WorldReset>();}},
  {"gz.msgs.WorldStatistics",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::WorldStatistics>();}},
  {"gz.msgs.Wrench",
    []()->std::unique_ptr<google::protobuf::Message>{return std::make_unique<gz::msgs::Wrench>();}},
}};
}  // namespace

namespace gz::msgs {
int RegisterAll() {
  size_t registered = 0;
  for (const auto &entry: kFactoryFunctions) {
    gz::msgs::Factory::Register(entry.first, entry.second);
    registered++;
  }
  return registered;
}

static int kMessagesRegistered = RegisterAll();
}  // namespace gz::msgs
